///
/// \file Buffer.cc
/// \author kyle 
/// \created 10/10/23
/// \brief Buffer implementation.
///
/// \section COPYRIGHT
/// Copyright 2023 K. Isom <kyle@imap.cc>
///
/// Permission to use, copy, modify, and/or distribute this software for
/// any purpose with or without fee is hereby granted, provided that the
/// above copyright notice and this permission notice appear in all copies.
///
/// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
/// WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
/// WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR
/// BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES
/// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
/// WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
/// ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
/// SOFTWARE.
///
/// @\section DESCRIPTION


#include <optional>
#include <random>
#include <sstream>

#include "Buffer.h"


static std::string
anonymousName()
{
	std::uniform_int_distribution<> dist(1000, 9999);
	std::random_device randomDevice;
	std::mt19937 rng(randomDevice());
	std::stringstream ss;

	ss << "Buffer<" << dist(rng) << ">";
	return ss.str();
}


Buffer::Buffer()
    : name(anonymousName()), path(std::nullopt), file(std::nullopt)
{
}


Buffer::Buffer(std::string fName)
    : name(std::move(fName)), path(std::nullopt), file(std::nullopt)
{

}


Buffer::Buffer(std::string fName, std::string fPath)
: name(std::move(fName)), path(std::move(fPath)), file(std::nullopt)
{
	if (this->path) {
		this->file = OptFile(File(this->path.value()));
	}

}


int Buffer::Flush(OptString altPath)
{
	return altPath ? 0 : 1;
}


void Buffer::ChangePath(std::string newPath)
{
	this->path = OptString(std::move(newPath));
}
